VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OfficeCalendar"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' From Tom Howe (howe@controlcenter.com)
' Copyright 1998; All rights reserved.

Public Sub ChangedItem(objCurrentMessage As Variant)

    ' An item in the personal calendar has been changed.
    ' The message object is passed to this procedure.
    ' Find the corresponding calendar item in the Office
    ' Calendar and delete it. The corresponding
    ' item on the Office Calendar has the same ID in the
    ' Message Object ConversationTopic Property.
    
    Dim objSession As MAPI.Session
    Dim objInfoStores As InfoStores
    Dim objInfoStore As InfoStore
    Dim objRootFolder As Folder
    Dim objfolders As Folders
    Dim objFolder As Folder
    Dim objMessages As Messages
    Dim objMessage As Message
    Dim strUniqueID As String
        
    Set objSession = New MAPI.Session

    ' Change the profile below to meet your offices needs.
    objSession.Logon ProfileName:="Administrator"

    Set objInfoStores = objSession.InfoStores
    Set objInfoStore = objInfoStores.Item("Public Folders")
    Set objRootFolder = objInfoStore.RootFolder
    Set objfolders = objRootFolder.Folders
    
    'All Public Folders.
    Set objfolders = objfolders.Item(2).Folders
  
    Set objFolder = objfolders.Item("Office Calendar")
                 
    Set objMessages = objFolder.Messages
       
    strUniqueID = objCurrentMessage.ConversationTopic
    
    For Each objMessage In objMessages
        
        If strUniqueID = objMessage.ConversationTopic Then
            
            objMessage.Delete
            
            Call AddItem(objCurrentMessage)
                        
        End If

    Next
    
    objSession.Logoff
    
    Set objMessage = Nothing
    Set objMessages = Nothing
    Set objFolder = Nothing
    Set objfolders = Nothing
    Set objRootFolder = Nothing
    Set objInfoStore = Nothing
    Set objInfoStores = Nothing
    Set objSession = Nothing
             
End Sub

Public Sub DeleteItem(objCurrentMessage As Variant)

    ' When an item is deleted from a personal calendar,
    ' the message object is gone before the delete event
    ' fires. Therefore, you cannot capture any property
    ' values of the message object. Therefore, this code
    ' is called (and the message object is passed) when the
    ' deleted item goes into the deleted items folder.

    ' If the deleted item is NOT an appointment item, ignore it.
    ' Check to see if the Conversation topic has an ID.
    On Error Resume Next
    If Left(objCurrentMessage.ConversationTopic, 1) = "Y" Then
        ' Do Nothing
    ElseIf Left(objCurrentMessage.ConversationTopic, 1) = "N" Then
        ' Do Nothing
    Else
        Exit Sub
    End If

    ' If the deleted item does not have a Conversation Topic
    ' property
    If Err.Number <> 0 Then
        Exit Sub
    End If
    
    ' Reset the error handler.
    On Error GoTo 0

    Dim objSession As MAPI.Session
    Dim objInfoStores As InfoStores
    Dim objInfoStore As InfoStore
    Dim objRootFolder As Folder
    Dim objfolders As Folders
    Dim objFolder As Folder
    Dim objMessages As Messages
    Dim objMessage As Message
    Dim strUniqueID As String
    Dim lngSize As Long
    Dim i As Integer
        
    Set objSession = New MAPI.Session

    ' Change the profile below to meet your offices needs.
    objSession.Logon ProfileName:="Administrator"

    Set objInfoStores = objSession.InfoStores
    Set objInfoStore = objInfoStores.Item("Public Folders")
    Set objRootFolder = objInfoStore.RootFolder
    Set objfolders = objRootFolder.Folders
    
    'All Public Folders.
    Set objfolders = objfolders.Item(2).Folders
  
    Set objFolder = objfolders.Item("Office Calendar")
                 
    Set objMessages = objFolder.Messages
       
    ' A message object for the item that has been deleted
    ' from a personal calendar has been passed into this
    ' procedure. Find the corresponding calendar item
    ' in the Office Calendar and delete it. The corresponding
    ' item on the Office Calendar has the same ID in the
    ' Message Object Conversation Property.
           
    strUniqueID = objCurrentMessage.ConversationTopic
    
    lngSize = objMessages.Count
    
    i = 1
    
    For i = 1 To lngSize
    
        Set objMessage = objMessages(lngSize - i + 1)
        
        If strUniqueID = objMessage.ConversationTopic Then
            
            ' Items deleted from the office
            ' calendar are not added to the
            ' deleted items folder for the
            ' mailbox so that script code
            ' does not run.
            objMessage.Delete
            
        End If
        
    Next i
        
    objSession.Logoff
    
    Set objMessage = Nothing
    Set objMessages = Nothing
    Set objFolder = Nothing
    Set objfolders = Nothing
    Set objRootFolder = Nothing
    Set objInfoStore = Nothing
    Set objInfoStores = Nothing
    Set objSession = Nothing
 
End Sub

Public Sub AddItem(objCurrentMessage As Variant)

    ' When an item is added to a personal calendar, add
    ' it to the office calendar. The message object for
    ' the item added is passed into this procedure.
    
    Dim objSession As MAPI.Session
    Dim objInfoStores As InfoStores
    Dim objInfoStore As InfoStore
    Dim objMailBox As InfoStore
    Dim objRootFolder As Folder
    Dim objfolders As Folders
    Dim objFolder As Folder
    Dim objCopiedMessage As Variant
    Dim objAddressList As AddressList
    Dim objAddressEntry As AddressEntry
    Dim strInitials As String
    Dim strMailBoxName As String
    Dim strMessageID As String
    Dim strFolderID As String
    Dim strOfficeCalendarItem As String
    
    Set objSession = New MAPI.Session
    
    ' Change the profile below to meet your offices needs.
    objSession.Logon ProfileName:="Administrator"
    
    ' Reference the Recipient based on the Mailbox.
    ' Cannot use Sender of message since users can share
    ' calendars and add appointment items to others
    ' calendars.
    Set objMailBox = objSession.GetInfoStore(objCurrentMessage.StoreID)
    
    strMailBoxName = Mid(objMailBox.Name, 11)
         
    ' Reference the Global Address List
    Set objAddressList = objSession.AddressLists.Item("Global Address List")
      
    Set objAddressEntry = objAddressList.AddressEntries(strMailBoxName)
    
    ' Get the initials for the user. When entering new
    ' mailboxes, make sure to enter the initials for the user.
    strInitials = objAddressEntry.Fields(CdoPR_INITIALS).Value
        
    Set objInfoStores = objSession.InfoStores
    Set objInfoStore = objInfoStores.Item("Public Folders")
    Set objRootFolder = objInfoStore.RootFolder
    Set objfolders = objRootFolder.Folders
    
    Set objfolders = objfolders.Item(2).Folders 'All Public Folders.
  
    Set objFolder = objfolders.Item("Office Calendar")
       
    strFolderID = objFolder.ID
        
    strInitials = strInitials & "- "
             
    ' When the calendar item was saved, code in the Outlook form
    ' presented the user with a dialog box asking if they wanted
    ' the item saved to the Office Calendar. If they chose "No",
    ' the Importance" property was set to 0, otherwise, the
    ' Importance property used the default value of 1
    If objCurrentMessage.Importance = 0 Then
        strOfficeCalendarItem = "N"
    Else
        strOfficeCalendarItem = "Y"
    End If
    
    ' The ConversationTopic property is used to hold
    ' a unique value (since this property is usually
    ' not used for appointment items.
    ' In the ConversationTopic property, include:
    ' Senders Name:Date/Time:Subject. The Date/Time
    ' is converted to a number. This is the unique
    ' value that will associated the item in the
    ' personal calendar and office calendar. When
    ' items are deleted or changed on the personal
    ' calendar, this value is used to sync the office
    ' calendar.
    
    objCurrentMessage.ConversationTopic = strOfficeCalendarItem & ":" & objCurrentMessage.Sender & ":" & CDbl(objCurrentMessage.TimeCreated) & ":" & objCurrentMessage.Subject
               
    If objCurrentMessage.Sensitivity = 2 Then
        objCurrentMessage.Subject = "Private"
        objCurrentMessage.Text = "Private"
    End If

    ' Save the changes to the Sender property for the
    ' calendar item added to the personal calendar.
    objCurrentMessage.Update
         
    objCurrentMessage.Subject = strInitials & objCurrentMessage.Subject
        
    ' If there is no category, add item to Office Calendar
    If IsEmpty(objCurrentMessage.Categories) Then
    
        Set objCopiedMessage = objCurrentMessage.CopyTo(objFolder.ID)
    
        objCopiedMessage.Update

    Else

        ' Do not add Holidays to Office Calendar.
        If objCurrentMessage.Categories()(0) = "Holiday" Then
        
            ' Do Nothing
        
        Else
        
            ' If the user specified that the item should be
            ' added to the Office Calendar, do it.
            If Left(strOfficeCalendarItem, 1) = "Y" Then
               
                Set objCopiedMessage = objCurrentMessage.CopyTo(objFolder.ID)
                objCopiedMessage.Update
                
            Else
                
                ' Do Nothing
                
            End If
        
        End If
        
    End If
              
    objSession.Logoff
    
    Set objCopiedMessage = Nothing
    Set objFolder = Nothing
    Set objfolders = Nothing
    Set objRootFolder = Nothing
    Set objInfoStore = Nothing
    Set objInfoStores = Nothing
    Set objAddressList = Nothing
    Set objAddressEntry = Nothing
    Set objMailBox = Nothing
    Set objSession = Nothing
    
End Sub

Private Sub Class_Initialize()

    Dim pintFreeFile As Integer

    pintFreeFile = FreeFile
  
    Open "C:\Init.Txt" For Append As pintFreeFile

    Write #pintFreeFile, "Initialize " & Now
    
    Close #pintFreeFile

End Sub

Private Sub Class_Terminate()

    Dim pintFreeFile As Integer

    pintFreeFile = FreeFile
  
    Open "C:\Term.Txt" For Append As pintFreeFile

    Write #pintFreeFile, "Terminate " & Now
    
    Close #pintFreeFile
    
End Sub
